

def isint(s):
    try:
        int(s)
        return True
    except ValueError:
        return False


def readconllufile(fname):
    sentences = []
    with open(fname, 'r', encoding="utf-8") as f:
        sentence = []
        i = 0
        errors = 0
        for line in f:
            if len(line) > 1:
                if line[0] != '#':
                    w = line.split("\t")
                    if len(w) != 10 and error < 10:
                        print("Incorrect number of fields on line " + str(i))
                        error += 1
                        if error >= 10:
                            print("More than 10 errors will not be printed")
                    token = {"ID": w[0], "FORM": w[1], "LEMMA": w[2], "UPOS": w[3], "XPOS": w[4], "FEATS": w[5], "HEAD": w[6], "DEPREL": w[7], "DEPS": w[8], "MISC": w[9]}
                else:
                    token = {"COMMENT": line}
                sentence.append(token)
            else:
                sentences.append(sentence)
                sentence = []
            i += 1
    return sentences


def prepareforpostagging(sentences):
    new_sentences = []
    for s in sentences:
        ns = [[w["FORM"], w["UPOS"]] for w in s if "COMMENT" not in w and isint(w["ID"])]
        new_sentences.append(ns)
    return new_sentences
